package xyz.stachel.zombiesutils.config;

import dev.isxander.yacl3.api.ConfigCategory;
import dev.isxander.yacl3.api.Option;
import dev.isxander.yacl3.api.OptionDescription;
import dev.isxander.yacl3.api.controller.FloatSliderControllerBuilder;
import dev.isxander.yacl3.config.v2.api.SerialEntry;
import net.minecraft.text.Text;

public class PlayerVisibilityConfig {


  @SerialEntry
  private float range;

  ConfigCategory category(PlayerVisibilityConfig defaults) {
    return ConfigCategory.createBuilder()
      .name(Text.translatable("zombies-utils.config.player-visibility.name"))
      .tooltip(Text.translatable("zombies-utils.config.player-visibility.tooltip"))

      .option(Option.<Float>createBuilder()
        .name(Text.translatable("zombies-utils.config.player-visibility.range.name"))
        .description(OptionDescription.of(Text.translatable("zombies-utils.config.player-visibility.range.tooltip")))
        .binding(defaults.range, () -> this.range, n -> {this.range = n;})
        .controller( o -> FloatSliderControllerBuilder.create(o).range(0f, 10f).step(0.01f))
        .build()

      ).build();
  }
}
