package xyz.stachel.zombiesutils.config;

import dev.isxander.yacl3.api.YetAnotherConfigLib;
import dev.isxander.yacl3.config.v2.api.ConfigClassHandler;
import dev.isxander.yacl3.config.v2.api.SerialEntry;
import dev.isxander.yacl3.config.v2.api.serializer.GsonConfigSerializerBuilder;
import net.fabricmc.loader.api.FabricLoader;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.screen.Screen;
import xyz.stachel.zombiesutils.ZombiesUtils;

public class ZombiesUtilsConfig {
  private static final ConfigClassHandler<ZombiesUtilsConfig> configHandler = ConfigClassHandler
      .createBuilder(ZombiesUtilsConfig.class)
      .serializer(cfg -> GsonConfigSerializerBuilder.create(cfg).setPath(FabricLoader.getInstance().getConfigDir().resolve(ZombiesUtils.MOD_ID).resolve("config.json")).build()).build();

  public ZombiesUtilsConfig() {
    this.playerVis = new PlayerVisibilityConfig();
  }

  @SerialEntry
  PlayerVisibilityConfig playerVis;

  public void display() {
    Screen screen = YetAnotherConfigLib.create(configHandler, (defaults, current, b) -> b
        .category(current.playerVis.category(defaults.playerVis)))
      .generateScreen(null);
    MinecraftClient.getInstance().setScreen(screen);
  }

  public static void init() {
    ZombiesUtilsConfig.configHandler.load();
  }

  public static ZombiesUtilsConfig getConfig() {
    return ZombiesUtilsConfig.configHandler.instance();
  }
}
